
/* 
 * Copyright (c) 1993-2003,2012 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef imu_POSTER_LIB_H
#define imu_POSTER_LIB_H

#include "posterLib.h"
#include "genom/genom.h"

/* Types definis ou utilises par le module */
#include "imuType.h"
#include "imuError.h"

/* 
 * Definition de la SDI_C 
*/
typedef struct {
  CNTRL_TASK_DESCRIPTION cntrlTask;
  EXEC_TASK_DESCRIPTION execTaskTab[IMU_NB_EXEC_TASK];
  ACTIVITY_DESCRIPTION activityTab[MAX_ACTIVITIES];
} IMU_CNTRL_STR;

/* For consistency with other posters */
typedef IMU_CNTRL_STR IMU_CNTRL_POSTER_STR;
 
/* 
 * Definition des structures de posters
 */
#include "imuPosterLibStruct.h"



/* Posters */
#define IMU_CNTRL_POSTER_NAME genomInstanceSuffixName("imu", "Cntrl")
#define IMU_SENSORS_POSTER_NAME genomInstanceSuffixName("imu", "Sensors")
#define IMU_ATTITUDEESTIMATION_POSTER_NAME genomInstanceSuffixName("imu", "AttitudeEstimation")
#define IMU_SEPOS_POSTER_NAME genomInstanceSuffixName("imu", "SEPos")
#define IMU_MONITORING_POSTER_NAME genomInstanceSuffixName("imu", "Monitoring")


/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif
extern STATUS imuPosterInit ( void );
extern POSTER_ID imuCntrlPosterID ();
extern STATUS imuCntrlPosterRead ( IMU_CNTRL_STR *imuCntrlStrId );
extern STATUS imuCntrlPosterInit ( void );
extern STATUS imuCntrlInstancePosterRead(const char *name, IMU_CNTRL_STR *imuCntrlStrId);
extern STATUS imuSensorsPosterInit ( void );
extern POSTER_ID imuSensorsPosterID ( void );
extern STATUS imuSensorsPosterRead ( IMU_SENSORS_POSTER_STR *x );
extern STATUS imuSensorsInstancePosterRead ( const char *, IMU_SENSORS_POSTER_STR * );
extern STATUS imuSensorssensorsPosterRead ( ImuPoster *sensors );
extern STATUS imuSensorssensorsInstancePosterRead( const char *, ImuPoster * );
extern STATUS imuAttitudeEstimationPosterInit ( void );
extern POSTER_ID imuAttitudeEstimationPosterID ( void );
extern STATUS imuAttitudeEstimationPosterRead ( IMU_ATTITUDEESTIMATION_POSTER_STR *x );
extern STATUS imuAttitudeEstimationInstancePosterRead ( const char *, IMU_ATTITUDEESTIMATION_POSTER_STR * );
extern STATUS imuAttitudeEstimationattitudeEstimationPosterRead ( IMU_ATTITUDE_ESTIMATION *attitudeEstimation );
extern STATUS imuAttitudeEstimationattitudeEstimationInstancePosterRead( const char *, IMU_ATTITUDE_ESTIMATION * );
extern STATUS imuSEPosPosterInit ( void );
extern POSTER_ID imuSEPosPosterID ( void );
extern STATUS imuSEPosPosterRead ( IMU_SEPOS_POSTER_STR *x );
extern STATUS imuSEPosInstancePosterRead ( const char *, IMU_SEPOS_POSTER_STR * );
extern STATUS imuSEPosposPosterRead ( POM_SENSOR_POS *pos );
extern STATUS imuSEPosposInstancePosterRead( const char *, POM_SENSOR_POS * );
extern STATUS imuMonitoringPosterInit ( void );
extern POSTER_ID imuMonitoringPosterID ( void );
extern STATUS imuMonitoringPosterRead ( IMU_MONITORING_POSTER_STR *x );
extern STATUS imuMonitoringInstancePosterRead ( const char *, IMU_MONITORING_POSTER_STR * );
extern STATUS imuMonitoringmonitorDataPosterRead ( IMU_MONITOR_DATA *monitorData );
extern STATUS imuMonitoringmonitorDataInstancePosterRead( const char *, IMU_MONITOR_DATA * );
#ifdef __cplusplus
}
#endif
#endif

