/* 
 * Copyright (c) 1993-2010 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef IMU_PRINT_H
#define IMU_PRINT_H


/* Structures definies par d'autres modules */

#include "server/tclservClient/genBasicTclservClientEncode.h"

#include "server/tclservClient/gyroTclservClientEncode.h"

#include "server/tclservClient/pomTclservClientEncode.h"


#include "server/imuPosterLib.h"

/* Prototypes */
#ifdef __cplusplus
extern "C" {
#endif
void buf_add_struct_IMU_MONITORING_POSTER_STR ( buf_t buf, struct IMU_MONITORING_POSTER_STR *x, int nDim, int *dims);
void buf_add_struct_IMU_SEPOS_POSTER_STR ( buf_t buf, struct IMU_SEPOS_POSTER_STR *x, int nDim, int *dims);
void buf_add_struct_IMU_ATTITUDEESTIMATION_POSTER_STR ( buf_t buf, struct IMU_ATTITUDEESTIMATION_POSTER_STR *x, int nDim, int *dims);
void buf_add_struct_IMU_SENSORS_POSTER_STR ( buf_t buf, struct IMU_SENSORS_POSTER_STR *x, int nDim, int *dims);
void buf_add_struct_ImuIDS ( buf_t buf, struct ImuIDS *x, int nDim, int *dims);
void buf_add_struct_IMU_MONITOR_PARAMS ( buf_t buf, struct IMU_MONITOR_PARAMS *x, int nDim, int *dims);
void buf_add_enum_IMU_MONITOR_LOG_FLAG ( buf_t buf, enum IMU_MONITOR_LOG_FLAG *x, int nDim, int *dims);
void buf_add_struct_IMU_MONITOR_DATA ( buf_t buf, struct IMU_MONITOR_DATA *x, int nDim, int *dims);
void buf_add_enum_IMU_MONITOR_STATUS ( buf_t buf, enum IMU_MONITOR_STATUS *x, int nDim, int *dims);
void buf_add_struct_IMU_ATTITUDE_ESTIMATION ( buf_t buf, struct IMU_ATTITUDE_ESTIMATION *x, int nDim, int *dims);
void buf_add_struct_IMU_BACKSTEPPING_PARAMS ( buf_t buf, struct IMU_BACKSTEPPING_PARAMS *x, int nDim, int *dims);
void buf_add_enum_IMU_BACKSTEP_MODE ( buf_t buf, enum IMU_BACKSTEP_MODE *x, int nDim, int *dims);
void buf_add_struct_IMU_COMPUTEANGSPEEDSBIASES_PARAMS ( buf_t buf, struct IMU_COMPUTEANGSPEEDSBIASES_PARAMS *x, int nDim, int *dims);
void buf_add_struct_IMU_COMPUTEACCELBIASES_PARAMS ( buf_t buf, struct IMU_COMPUTEACCELBIASES_PARAMS *x, int nDim, int *dims);
void buf_add_struct_IMU_SETACCELBIASES_PARAMS ( buf_t buf, struct IMU_SETACCELBIASES_PARAMS *x, int nDim, int *dims);
void buf_add_struct_IMU_SETSENSORSDATA_PARAMS ( buf_t buf, struct IMU_SETSENSORSDATA_PARAMS *x, int nDim, int *dims);
void buf_add_struct_IMU_GETSENSORSDATA_PARAMS ( buf_t buf, struct IMU_GETSENSORSDATA_PARAMS *x, int nDim, int *dims);
void buf_add_struct_IMU_FILTER_PARAMS ( buf_t buf, struct IMU_FILTER_PARAMS *x, int nDim, int *dims);
void buf_add_enum_IMU_FILTER_MODE ( buf_t buf, enum IMU_FILTER_MODE *x, int nDim, int *dims);
void buf_add_struct_IMU_VARIANCES ( buf_t buf, struct IMU_VARIANCES *x, int nDim, int *dims);
void buf_add_struct_IMU_INTEGRATEDDATA_INITVALUES ( buf_t buf, struct IMU_INTEGRATEDDATA_INITVALUES *x, int nDim, int *dims);
void buf_add_struct_IMU_DUMPONFILE_PARAMS ( buf_t buf, struct IMU_DUMPONFILE_PARAMS *x, int nDim, int *dims);
void buf_add_struct_ImuPoster ( buf_t buf, struct ImuPoster *x, int nDim, int *dims);
void buf_add_struct_ImuDevice ( buf_t buf, struct ImuDevice *x, int nDim, int *dims);

/* ======================== PRINT DES TYPEDEF ============================= */

void buf_add_ImuDevice ( buf_t buf, ImuDevice *x, int nDim, int *dims);
void buf_add_ImuPoster ( buf_t buf, ImuPoster *x, int nDim, int *dims);
void buf_add_IMU_DUMPONFILE_PARAMS ( buf_t buf, IMU_DUMPONFILE_PARAMS *x, int nDim, int *dims);
void buf_add_IMU_INTEGRATEDDATA_INITVALUES ( buf_t buf, IMU_INTEGRATEDDATA_INITVALUES *x, int nDim, int *dims);
void buf_add_IMU_VARIANCES ( buf_t buf, IMU_VARIANCES *x, int nDim, int *dims);
void buf_add_IMU_FILTER_MODE ( buf_t buf, IMU_FILTER_MODE *x, int nDim, int *dims);
void buf_add_IMU_FILTER_PARAMS ( buf_t buf, IMU_FILTER_PARAMS *x, int nDim, int *dims);
void buf_add_IMU_GETSENSORSDATA_PARAMS ( buf_t buf, IMU_GETSENSORSDATA_PARAMS *x, int nDim, int *dims);
void buf_add_IMU_SETSENSORSDATA_PARAMS ( buf_t buf, IMU_SETSENSORSDATA_PARAMS *x, int nDim, int *dims);
void buf_add_IMU_SETACCELBIASES_PARAMS ( buf_t buf, IMU_SETACCELBIASES_PARAMS *x, int nDim, int *dims);
void buf_add_IMU_COMPUTEACCELBIASES_PARAMS ( buf_t buf, IMU_COMPUTEACCELBIASES_PARAMS *x, int nDim, int *dims);
void buf_add_IMU_COMPUTEANGSPEEDSBIASES_PARAMS ( buf_t buf, IMU_COMPUTEANGSPEEDSBIASES_PARAMS *x, int nDim, int *dims);
void buf_add_IMU_BACKSTEP_MODE ( buf_t buf, IMU_BACKSTEP_MODE *x, int nDim, int *dims);
void buf_add_IMU_BACKSTEPPING_PARAMS ( buf_t buf, IMU_BACKSTEPPING_PARAMS *x, int nDim, int *dims);
void buf_add_IMU_ATTITUDE_ESTIMATION ( buf_t buf, IMU_ATTITUDE_ESTIMATION *x, int nDim, int *dims);
void buf_add_IMU_MONITOR_STATUS ( buf_t buf, IMU_MONITOR_STATUS *x, int nDim, int *dims);
void buf_add_IMU_MONITOR_DATA ( buf_t buf, IMU_MONITOR_DATA *x, int nDim, int *dims);
void buf_add_IMU_MONITOR_LOG_FLAG ( buf_t buf, IMU_MONITOR_LOG_FLAG *x, int nDim, int *dims);
void buf_add_IMU_MONITOR_PARAMS ( buf_t buf, IMU_MONITOR_PARAMS *x, int nDim, int *dims);
void buf_add_ImuIDS ( buf_t buf, ImuIDS *x, int nDim, int *dims);
void buf_add_IMU_SENSORS_POSTER_STR ( buf_t buf, IMU_SENSORS_POSTER_STR *x, int nDim, int *dims);
void buf_add_IMU_ATTITUDEESTIMATION_POSTER_STR ( buf_t buf, IMU_ATTITUDEESTIMATION_POSTER_STR *x, int nDim, int *dims);
void buf_add_IMU_SEPOS_POSTER_STR ( buf_t buf, IMU_SEPOS_POSTER_STR *x, int nDim, int *dims);
void buf_add_IMU_MONITORING_POSTER_STR ( buf_t buf, IMU_MONITORING_POSTER_STR *x, int nDim, int *dims);
#ifdef __cplusplus
}
#endif

#endif /* IMU_TCLSERV_CLIENT_ENCODE_H */

