
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef imu_TCLSERV_CLIENT_MSG_LIB_H
#define imu_TCLSERV_CLIENT_MSG_LIB_H

#include <server/imuType.h>

/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int imuTclservClientInit (TCLSERV_CLIENT_ID pClientId);

int imuTclservClientEnd (TCLSERV_CLIENT_ID clientId);



int imuTclservClientInitRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 ImuDevice *(in_device) 
		);

int imuTclservClientInitReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int imuTclservClientInitRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				ImuDevice *(in_device) ,
				
				int *bilan);

int imuTclservClientInitRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					ImuDevice *(in_device) ,
					
					int *bilan);




int imuTclservClientGetInitParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int imuTclservClientGetInitParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       ImuDevice *(out_device),
			       int *bilan);

int imuTclservClientGetInitParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 ImuDevice *(out_device),
				 int *bilan);




int imuTclservClientZeroRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 double *(in_zero) 
		);

int imuTclservClientZeroReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int imuTclservClientZeroRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				double *(in_zero) ,
				
				int *bilan);

int imuTclservClientZeroRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					double *(in_zero) ,
					
					int *bilan);




int imuTclservClientGetDeviceVersionRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int imuTclservClientGetDeviceVersionReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int imuTclservClientGetDeviceVersionRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int imuTclservClientGetDeviceVersionRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int imuTclservClientSetAccelBiasesRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 IMU_SETACCELBIASES_PARAMS *(in_setAccelBiasesParams)
		);

int imuTclservClientSetAccelBiasesReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int imuTclservClientSetAccelBiasesRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 IMU_SETACCELBIASES_PARAMS *(in_setAccelBiasesParams) ,
				 
				 int *bilan);




int imuTclservClientComputeAccelBiasesRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 IMU_COMPUTEACCELBIASES_PARAMS *(in_computeAccelBiasesParams) 
		);

int imuTclservClientComputeAccelBiasesReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int imuTclservClientComputeAccelBiasesRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				IMU_COMPUTEACCELBIASES_PARAMS *(in_computeAccelBiasesParams) ,
				
				int *bilan);

int imuTclservClientComputeAccelBiasesRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					IMU_COMPUTEACCELBIASES_PARAMS *(in_computeAccelBiasesParams) ,
					
					int *bilan);




int imuTclservClientComputeAngSpeedsBiasesRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 IMU_COMPUTEANGSPEEDSBIASES_PARAMS *(in_computeAngSpeedsBiasesParams) 
		);

int imuTclservClientComputeAngSpeedsBiasesReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int imuTclservClientComputeAngSpeedsBiasesRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				IMU_COMPUTEANGSPEEDSBIASES_PARAMS *(in_computeAngSpeedsBiasesParams) ,
				
				int *bilan);

int imuTclservClientComputeAngSpeedsBiasesRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					IMU_COMPUTEANGSPEEDSBIASES_PARAMS *(in_computeAngSpeedsBiasesParams) ,
					
					int *bilan);




int imuTclservClientDumpImuDataOnFileRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 IMU_DUMPONFILE_PARAMS *(in_dumpOnFileParams) 
		);

int imuTclservClientDumpImuDataOnFileReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int imuTclservClientDumpImuDataOnFileRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				IMU_DUMPONFILE_PARAMS *(in_dumpOnFileParams) ,
				
				int *bilan);

int imuTclservClientDumpImuDataOnFileRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					IMU_DUMPONFILE_PARAMS *(in_dumpOnFileParams) ,
					
					int *bilan);




int imuTclservClientDumpImuDataStopRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int imuTclservClientDumpImuDataStopReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int imuTclservClientDumpImuDataStopRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int imuTclservClientGetSensorsDataRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 IMU_GETSENSORSDATA_PARAMS *(in_getSensorsDataParams) 
		);

int imuTclservClientGetSensorsDataReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int imuTclservClientGetSensorsDataRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				IMU_GETSENSORSDATA_PARAMS *(in_getSensorsDataParams) ,
				
				int *bilan);

int imuTclservClientGetSensorsDataRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					IMU_GETSENSORSDATA_PARAMS *(in_getSensorsDataParams) ,
					
					int *bilan);




int imuTclservClientSetSensorsDataNumFileRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 IMU_SETSENSORSDATA_PARAMS *(in_setSensorsDataParams)
		);

int imuTclservClientSetSensorsDataNumFileReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int imuTclservClientSetSensorsDataNumFileRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 IMU_SETSENSORSDATA_PARAMS *(in_setSensorsDataParams) ,
				 
				 int *bilan);




int imuTclservClientInitIntegratedDataRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 IMU_INTEGRATEDDATA_INITVALUES *(in_initValues) 
		);

int imuTclservClientInitIntegratedDataReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int imuTclservClientInitIntegratedDataRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				IMU_INTEGRATEDDATA_INITVALUES *(in_initValues) ,
				
				int *bilan);

int imuTclservClientInitIntegratedDataRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					IMU_INTEGRATEDDATA_INITVALUES *(in_initValues) ,
					
					int *bilan);




int imuTclservClientSetVariancesRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 IMU_VARIANCES *(in_imuVariances)
		);

int imuTclservClientSetVariancesReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int imuTclservClientSetVariancesRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 IMU_VARIANCES *(in_imuVariances) ,
				 
				 int *bilan);




int imuTclservClientFilterImuDataRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 IMU_FILTER_PARAMS *(in_imuDataFilterParams)
		);

int imuTclservClientFilterImuDataReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int imuTclservClientFilterImuDataRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 IMU_FILTER_PARAMS *(in_imuDataFilterParams) ,
				 
				 int *bilan);




int imuTclservClientGetFilterParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int imuTclservClientGetFilterParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       IMU_FILTER_PARAMS *(out_imuDataFilterParams),
			       int *bilan);

int imuTclservClientGetFilterParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 IMU_FILTER_PARAMS *(out_imuDataFilterParams),
				 int *bilan);




int imuTclservClientBackStepAttitudeEstimationRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 IMU_BACKSTEPPING_PARAMS *(in_backStepParams) 
		);

int imuTclservClientBackStepAttitudeEstimationReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int imuTclservClientBackStepAttitudeEstimationRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				IMU_BACKSTEPPING_PARAMS *(in_backStepParams) ,
				
				int *bilan);

int imuTclservClientBackStepAttitudeEstimationRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					IMU_BACKSTEPPING_PARAMS *(in_backStepParams) ,
					
					int *bilan);




int imuTclservClientStopBackStepAttitudeEstimationRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int imuTclservClientStopBackStepAttitudeEstimationReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int imuTclservClientStopBackStepAttitudeEstimationRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int imuTclservClientGetBackStepAttitudeEstimationParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int imuTclservClientGetBackStepAttitudeEstimationParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       IMU_BACKSTEPPING_PARAMS *(out_backStepParams),
			       int *bilan);

int imuTclservClientGetBackStepAttitudeEstimationParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 IMU_BACKSTEPPING_PARAMS *(out_backStepParams),
				 int *bilan);




int imuTclservClientSetHeadingPosterRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 GEN_STRING64 *(in_headingPosterName) 
		);

int imuTclservClientSetHeadingPosterReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int imuTclservClientSetHeadingPosterRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				GEN_STRING64 *(in_headingPosterName) ,
				
				int *bilan);

int imuTclservClientSetHeadingPosterRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					GEN_STRING64 *(in_headingPosterName) ,
					
					int *bilan);




int imuTclservClientFlatTerrainMonitorRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 IMU_MONITOR_PARAMS *(in_monitorParams) 
		);

int imuTclservClientFlatTerrainMonitorReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int imuTclservClientFlatTerrainMonitorRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				IMU_MONITOR_PARAMS *(in_monitorParams) ,
				
				int *bilan);

int imuTclservClientFlatTerrainMonitorRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					IMU_MONITOR_PARAMS *(in_monitorParams) ,
					
					int *bilan);




int imuTclservClientStopMonitorRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int imuTclservClientStopMonitorReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int imuTclservClientStopMonitorRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int imuTclservClientGetMonitorParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int imuTclservClientGetMonitorParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       IMU_MONITOR_PARAMS *(out_monitorParams),
			       int *bilan);

int imuTclservClientGetMonitorParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 IMU_MONITOR_PARAMS *(out_monitorParams),
				 int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* imuTCLSERV_CLIENT_MSG_LIB_H */

